// Code generated by github.com/seeflood/protoc-gen-p6 .

// Copyright 2021 Layotto Authors
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package cryption

// EncryptRequest is the request to encrypt data.
type EncryptRequest struct {
	// The cryption service name, e.g. 'aliyun.kms'
	ComponentName string `json:"component_name,omitempty"`
	// Required. Raw plaintext.
	PlainText []byte `json:"plain_text,omitempty"`
	// Required.
	KeyId string `json:"key_id,omitempty"`
}

// EncryptResponse is the response of the `Encrypt` method.
type EncryptResponse struct {
	// The encrypted text
	CipherText []byte `json:"cipher_text,omitempty"`
	// The id of the key used to decrypt this text.
	KeyId string `json:"key_id,omitempty"`
	// The version of the key
	KeyVersionId string `json:"key_version_id,omitempty"`
}

// DecryptRequest is the request of the `Decrypt` method.
type DecryptRequest struct {
	// The cryption service name, e.g. 'aliyun.kms'
	ComponentName string `json:"component_name,omitempty"`
	// Required. The encrypted text
	CipherText []byte `json:"cipher_text,omitempty"`
}

// DecryptResponse is the response of the `Decrypt` method.
type DecryptResponse struct {
	// Raw plaintext.
	PlainText []byte `json:"plain_text,omitempty"`
	// The id of the key used to decrypt this text.
	KeyId string `json:"key_id,omitempty"`
	// The version of the key
	KeyVersionId string `json:"key_version_id,omitempty"`
}
