// Code generated by github.com/layotto/protoc-gen-p6 .

// Copyright 2021 Layotto Authors
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package email

// SendEmailWithTemplateRequest is the message send to email.
type SendEmailWithTemplateRequest struct {
	// The saas service name, like 'aliyun.email'/'aws.ses'/'...'
	//  If your system uses multiple IVR services at the same time,
	//  you can specify which service to use with this field.
	ComponentName string `json:"component_name,omitempty"`
	// Required.
	Template *EmailTemplate `json:"template,omitempty"`
	// Required. The Email subject.
	Subject string `json:"subject,omitempty"`
	// Required.
	Address *EmailAddress `json:"address,omitempty"`
}

// Address information
type EmailAddress struct {
	// Required. The Email sender address.
	From string `json:"from,omitempty"`
	// Required. The Email destination addresses.
	To []string `json:"to,omitempty"`
	// Optional. To whom the mail is cc
	Cc []string `json:"cc,omitempty"`
}

// Email template
type EmailTemplate struct {
	// Required
	TemplateId string `json:"template_id,omitempty"`
	// Required
	TemplateParams map[string]string `json:"template_params,omitempty"`
}

// Response of `SendEmailWithTemplate` method
type SendEmailWithTemplateResponse struct {
	// The saas requestId.
	RequestId string `json:"request_id,omitempty"`
}

// SendEmailRequest is the message send to email.
type SendEmailRequest struct {
	// The saas service name, like 'aliyun.email'/'aws.ses'/'...'
	//  If your system uses multiple IVR services at the same time,
	//  you can specify which service to use with this field.
	ComponentName string `json:"component_name,omitempty"`
	// Required.
	SettingId string `json:"setting_id,omitempty"`
	// Required. The Email subject.
	Subject string `json:"subject,omitempty"`
	//  Required.
	Content *Content `json:"content,omitempty"`
	// Required.
	Address *EmailAddress `json:"address,omitempty"`
}

// Email content
type Content struct {
	// Required.
	Text string `json:"text,omitempty"`
}

// The response of `SendEmail` method
type SendEmailResponse struct {
	// The saas requestId.
	RequestId string `json:"request_id,omitempty"`
}
