- [Home](/en/README.md)
- Quick start
  - [Use State API](en/start/state/start.md)
  - Use Configuration API
    - [Use Apollo as configuration center](en/start/configuration/start-apollo.md)
    - [Use Etcd as configuration center](en/start/configuration/start.md)
  - Publish or subscribe messages
    - [Use Pub/Sub API](en/start/pubsub/start.md)
    - [(Under construction) Use DelayQueue API](en/start/delay_queue/start)
  - [Use Distributed Lock API](en/start/lock/start.md)
  - [Use Sequencer API](en/start/sequencer/start.md)
  - Use Secret API
    - [Query secrets](en/start/secret/start.md)
    - [Refer to secrets in component configuration](en/start/secret/secret_ref.md)
  - Service Invocation
    - [Hello World](en/start/rpc/helloworld.md)
    - [Dubbo JSON RPC](en/start/rpc/dubbo_json_rpc.md)    
  - [Use OSS API](en/start/oss/start.md)
  - API plugin
    - [Register your own API](en/start/api_plugin/helloworld.md)
    - [Generate API plugin automatically](en/start/api_plugin/generate.md)
  <!--quickstart_generator-->  
  - [(Under construction) Use sms API](en/start/sms/start) 
  - [(Under construction) Use cryption API](en/start/cryption/start) 
  - [(Under construction) Use phone API](en/start/phone/start) 
  - [(Under construction) Use email API](en/start/email/start) 
  - [Use lifecycle API](en/start/lifecycle/start) 
  - As the data plane of istio
    - [Integrate with istio 1.10.6](en/start/istio/)
    - [Integrate with istio 1.5.x](en/start/istio/start.md)
  - Traffic intervention on the 4th layer network
    - [Dump TCP Traffic](en/start/network_filter/tcpcopy.md)
  - Flow Control on the 7th layer network
    - [Method Level Flow Control](en/start/stream_filter/flow_control.md)
  - Observability
    - [Tracing & Metrics](en/start/trace/trace.md)
    - [Skywalking tracing](en/start/trace/skywalking.md)
    - [Prometheus metrics](en/start/trace/prometheus.md)
  - [Health check and metadata query](en/start/actuator/start.md)
  - [Run business logic in Layotto using WASM](en/start/wasm/start.md)
  - [FaaS model based on WASM and Runtime](en/start/faas/start.md)
- [Online lab](en/start/lab.md)  
- Developer guide
  - Building blocks
    - [File API](en/building_blocks/file/file.md)
    - [Actuator API](en/building_blocks/actuator/actuator.md)
    - [State API](en/building_blocks/state/reference.md)
    - [Sequencer API](en/building_blocks/sequencer/reference.md)
    - [Distributed Lock API](en/building_blocks/lock/reference.md)
    - [Pub/Sub API](en/building_blocks/pubsub/reference.md)
    - [RPC API](en/building_blocks/rpc/reference.md)    
    - [Configuration API](en/building_blocks/configuration/reference.md)
  - [API reference](en/api_reference/README)
  - SDK reference
    - [java sdk](https://github.com/layotto/java-sdk)
    - [.net sdk](https://github.com/layotto/dotnet-sdk)
    - [js sdk](https://github.com/layotto/js-sdk)
    - [go sdk](en/sdk_reference/go/start.md)
- Operations
  - How to configurate Layotto
    - [Introduction to Layotto configuration file](en/configuration/overview.md)  
    - [How to configurate the components](en/component_specs/overview.md)
      - [State](en/component_specs/state/common.md)
        - [Redis](en/component_specs/state/redis.md)
        - [Other components](en/component_specs/state/others.md)
      - Pub/Sub
        - [Redis](en/component_specs/pubsub/redis.md)
        - [Other components](en/component_specs/pubsub/others.md)
      - [Distributed Lock](en/component_specs/lock/common.md)
        - [Redis](en/component_specs/lock/redis.md)  
        - [Etcd](en/component_specs/lock/etcd.md)
        - [Zookeeper](en/component_specs/lock/zookeeper.md)
        - [Consul](en/component_specs/lock/consul.md)
        - [MongoDB](en/component_specs/lock/mongo.md)
      - Configuration
        - [Etcd](en/component_specs/configuration/etcd.md)
        - [Apollo](en/component_specs/configuration/apollo.md)
      - File
        - [OSS](en/component_specs/file/oss.md)
      - [Sequencer](en/component_specs/sequencer/common.md)
        - [Etcd](en/component_specs/sequencer/etcd.md)
        - [Redis](en/component_specs/sequencer/redis.md)
        - [Zookeeper](en/component_specs/sequencer/zookeeper.md)
        - [MongoDB](en/component_specs/sequencer/mongo.md)
        - [Mysql](en/component_specs/sequencer/mysql.md)
        - [Snowflake](en/component_specs/sequencer/snowflake.md)
      - [Secret Store](en/component_specs/secret/common.md)
  - [How to deploy and upgrade Layotto](en/operation/)
- Design documents
  - [Actuator design doc](en/design/actuator/actuator-design-doc.md)
  - [Configuration API with Apollo](en/design/configuration/configuration-api-with-apollo.md)
  - [Pub/Sub API and compability with dapr component](en/design/pubsub/pubsub-api-and-compability-with-dapr-component.md)
  - [RPC design doc](en/design/rpc/rpc-design-doc.md)
  - [Distributed lock API design](en/design/lock/lock-api-design.md)
  - [FaaS design](en/design/faas/faas-poc-design.md)
- Contributing
  - [Document Contribution Guide](en/development/contributing-doc.md)
  - [Automate testing of Quickstart documentation with tools](en/development/test-quickstart.md)
  - [Component Development Guide](en/development/developing-component.md)
  - Want to modify proto files or API definition?
    - [How to generate pb code and API reference](en/api_reference/how_to_generate_api_doc.md)
    - [Comment specification of proto file](en/api_reference/comment_spec_of_proto.md)
    - [Development specification when adding API](en/development/developing-api.md)
  - [Layotto Github Workflows Guide](en/development/github-workflows.md)
  - [Layotto Commands Guide](en/development/commands.md)
  - [Layotto contributor guide](en/development/CONTRIBUTING.md)

